package edu.swarthmore.cs.cs71.attendance;

import java.util.*;

public class AttendanceModel {
    private Set<Student> students;
    private Set<AttendableEvent> events;

    private Map<String, Student> studentsByUsername;

    private Map<Pair<Student,AttendableEvent>, Boolean> attendanceRecords;
    private Map<Student, Map<AttendableEvent, Boolean>> attendanceRecordsByStudent;
    private Map<AttendableEvent, Map<Student, Boolean>> attendanceRecordsByEvent;

    public AttendanceModel() {
        this.students = new HashSet<>();
        this.events = new HashSet<>();

        this.studentsByUsername = new HashMap<>();

        this.attendanceRecords = new HashMap<>();
        this.attendanceRecordsByStudent = new HashMap<>();
        this.attendanceRecordsByEvent = new HashMap<>();
    }

    public void setAttendance(Student student, AttendableEvent event, boolean present) {
        attendanceRecords.put(new Pair<>(student, event), present);
        if (!attendanceRecordsByStudent.containsKey(student)) {
            attendanceRecordsByStudent.put(student, new HashMap<>());
        }
        attendanceRecordsByStudent.get(student).put(event, present);
        if (!attendanceRecordsByEvent.containsKey(event)) {
            attendanceRecordsByEvent.put(event, new HashMap<>());
        }
        attendanceRecordsByEvent.get(event).put(student, present);
    }

    public void addStudent(Student student) {
        this.students.add(student);
        this.studentsByUsername.put(student.getUsername(), student);
    }

    public void addEvent(AttendableEvent event) {
        this.events.add(event);
    }
}
